/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************* bidon.h  **********************************/
/*                                                                     */
/*      descripteurs et prototypes associes a l'operateur bidon        */
/*                                                                     */
/*  Derniere modif : E. TROUVE, 18/10/99                               */
/* *********************************************************************/


/* pas de code avant cette ligne*/
#ifndef __bidon
#define __bidon

/** \ingroup bidon
Un ensemble de descripteur contenant les infos ncessaires pour l'oprateur bidon
*/
typedef struct {
    int dimX, dimY;    /**< exemple de parametre entier   */
    float gain;        /**< exemple de parametre reel */
    char forme[200];   /**< exemple de parametre de type chaine de charactere */
    imafl msq;        /**< exemple de variable : coeffs d'un masque (fl) */
} bidon_t;

param *bidon_lect(bidon_t *des, param *ptp, char *debq);
int bidonu1_init(bidon_t *des, imau1 im0, imau1 *imres);     
int bidonu1_calc(bidon_t *des, imau1 im0, imau1 *imres);     


/*pas de code aprs cette ligne */
#endif
