/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************* contourRSO.h  *****************************/
/*                                                                     */
/*      descripteurs et prototypes associes a l'operateur contour      */
/*                                                                     */
/*  Derniere modif : 15/06/00  F. Bujor, E. Trouve                     */
/* *********************************************************************/

/* pas de code avant cette ligne*/
#ifndef __contourRSO
#define __contourRSO

/* contour fin sur 360 degres */

/** \ingroup contourRSO 
descripteur pour l'oprateur de dtection de contour*/
typedef struct {
    char dim;       /**< dimension du masque (impair) */
    char qsauver;   /**< sauver les masques (1/0) */
    char maxloc;    /**< selection des contours max locaux dans la direction normale */
    imau1 msqv, msqh, msqdp, msqds;  /* images des masques */
    imafl rapv, raph, rapdp, rapds;  /* buffer 3 lignes des rapports */
} contourRSO_t;


/* operateur */
param *contourRSO_lect(contourRSO_t *des, param *ptp, char *debq);
int contourRSOu2_init(contourRSO_t *des, imau2 im0, imafl *imval, imau1 *imdir);
int contourRSOu2_calc(contourRSO_t *des, imau2 im0, imafl *imval, imau1 *imdir);


/* fonctions locales */
float appl_masque12(imau2 im0, imau1 msq, int i, int j, float *tab);
void valdirmax(float v, float h, float dp, float ds, float *ptval, pixu1 *ptdir);
int maxlocgrad(float val, float dir, int j, contourRSO_t *des);


/*pas de code aprs cette ligne */
#endif
