/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ********************** conv_img.h ***********************************/
/*                                                                     */
/*      descripteurs et prototypes associes a l'operateur lconv_img    */
/*                                                                     */
/*  Derniere modif : B. IONESCU, 15/12/00                              */
/* *********************************************************************/

#include "image.h"
#include "proto2D.h"
#include "rasterfile.h"
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>

typedef struct {
    
    pixdb **comp0, **comp1, **comp2;
    int type_conv;
    int transf_interm;
    pixdb comp_a, comp_b, comp_c;
    int nr, nc;

} space_struct;

void conv_TLS_RVB2(space_struct *des, imarvb *ima_tls, imarvb *ima_rvb);
void conv_RVB_TLS2(space_struct *des, imarvb *ima_rvb, imarvb *ima_tls);

double maxim(double i, double j);
double minim(double i, double j);
void conv_RVB_HSV(space_struct *des, imarvb *ima_rvb);
void conv_HSV_RVB(space_struct *des, imarvb *ima_rvb);

void toetRGB_to_XYZ(double RD, double VD, double BD, double *X, double *Y, double *Z);
void ceiRGB_to_XYZ(double RD, double VD, double BD, double *X, double *Y, double *Z);
void XYZ_to_ceiuvY(double X, double Y, double Z, double *u, double *v, double *Y1);
double f(double t);
void conv_RVB_Lab(space_struct *des, imarvb *ima_rvb);
void conv_RVB_Luv(space_struct *des, imarvb *ima_rvb);

param* conv_img_lect(space_struct *des, param *ptp, char *debq);
int conv_img_init(space_struct *des, imarvb im0, imarvb *imres);
int conv_img_calc(space_struct *des, imarvb im0, imarvb *imres);


int alloc_space_struct(space_struct *des, imarvb *im);
int free_space_struct(space_struct *des);







