/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef __decision_fusion_by_decision_templates
#define __decision_fusion_by_decision_templates


#include "image.h"
#include "proto2D.h"

#include <stdlib.h>
#include <glib.h>

#include "classifier.h"


/* ---------------------------------------------------
constantes 
-----------------------------------------------------*/


/* le premier element d'une GList commence a 0 */
#define PREMIER_ELEMENT           0

/* pour afficher nom fichier et ligne */
#define FICHIER_EN_COURS          __FILE__
#define LIGNE_EN_COURS             __LINE__

/* choix de la fonction de similitude */
#define NORME_LP 0

#define NO_ERROR 0

#define PRENDRE_CONTEXTE 1
#define NE_PAS_PRENDRE_CONTEXTE -1

#define NB_AFFICH 5

#define NE_PAS_SEUILLER 123045060//valeur improbable
#define SEUILLER 0


/*---------------------------------------------------
  descripteur 
  ---------------------------------------------------*/

 /* classes est une structure stockant : 
    -> les vrais labels, 
    -> le nombre de points par label 
    -> et les labels normaliss de 0 a nb_label - 1 */


typedef struct{
  int label_masque;
  int label_classifieur;
  int nb_pts;
  int label_norm;
}une_classe_inconnue;

  
typedef struct {
    int label_masque;
    int label_normalise;
    int nb_pts;
  }une_classe_DT; 


typedef struct{
  int *label;
  int *nb_pts;
}un_contexte;

  
typedef struct{
  
  /* les infos sur les classes */
  une_classe_DT *les_classes;
  
  /* point pb */
  une_classe_inconnue *classes_inconnues;
  int nb_class_inconnues;
  int nb_labels_inconnus;

  /* rejet */
  int label_rejet;

  /* contexte */
  int flag_contexte;
  int flag_contexte_apprent;
  un_contexte *contexte;
  int nb_voisins;
  int *nb_labels_contexte;
  int equ_nb_cols;
  int equ_nb_rows;
  int  nb_pts_effectif;
  int nb_voisins_apprent;
  int cpt_pt_apprent;

  /* pour les DT : chaque element est une dataoutput */
  data_output *data_field_of_glist_DT;

  /* La Glist des DT */
  GList *DT;

  /* seuil rejet */
  float seuil;

}decision_fusion_by_decision_templates_t;



/*---------------------------------------------------
  les operations
---------------------------------------------------*/

param *decision_fusion_by_decision_templates_lect(
						  decision_fusion_by_decision_templates_t *desc,
						  param *ptp,
						  char *debq
						  );


int decision_fusion_by_decision_templates_init(
					       decision_fusion_by_decision_templates_t *desc,
					       GList *DP,
					       data_output expert_decision,
					       const int LABEL_FOND,				       
					       float seuil,
					       int nb_voisins,
					       data_output *final_crisp_decision
					       );


int decision_fusion_by_decision_templates_calc(
					       decision_fusion_by_decision_templates_t *desc ,
					       GList *DP,
					       int similarity_measure_choix,
					       int indice_point,		
					       const int norme_lp,
					       data_output *crisp_decision 
					       );


int decision_fusion_by_decision_templates_ferm(
					       decision_fusion_by_decision_templates_t *desc
					       );



int calc_similarity_from_DP_to_DT_by_squared_norme_lp(GList *DP, decision_fusion_by_decision_templates_t *desc, int indice_point, const int norme_lp, float *result);


int calc_similarity_from_DP_to_DT_by_squared_norme_lp_with_contexte(  
								GList *DP, 
								decision_fusion_by_decision_templates_t *desc,
								int indice_point, 
								const int norme_lp,
								float *result
								);

int chercher_nb_class(data_output *dataO,int *labels);


int built_decisions_templates_by_arithmetic_mean(
						 decision_fusion_by_decision_templates_t *desc,
						 int labelfond,
						 int nb_class_classifieurs,
						 int type,
						 int nb_DT,
						 data_output mask_learn_DT ,
						 GList *DP					
						 );


int classifier_contexte_decision(data_output decision, int nb_voisins, data_output *contexte_decision);



#endif
