/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************* gradient_organisation.h  ***************************                                     descripteurs et prototypes associes a l'operateur du calcul de l'organisation 
   des gradients dans l'images 3D                                      
                                                                                
  Derniere modif : L. Valet, 22.11.2006                                        */
/* *****************************************************************************/
/*pas de code avant cette ligne */
#ifndef __grad_orga_3d
#define __grad_orga_3d

#include <stdio.h>
#include "volume.h"   /* descripteurs et prototypes des fonctions de ima3D */
#include "image.h"
#include "proto2D.h"

typedef struct{
  float alpha; /*filtrage de deriche*/
  int ax,ay,az; /*dimension pour le calcul de l'ACP des gradients*/
  int tgrad; /*dimension pour le calcul des gradients d'intensit*/
  int type; /*type de la sortie*/
  float normalisation;
  short **gradx, **grady, **gradz;
  float *acp_x, *acp_y, *acp_z;
  float *conf1, *conf2, *conf3; 
  float alp;
} ogi_t; /*organisation des gradients d'intensit*/



param* gradient_organisation_lect(ogi_t* des, param* ptp, char* debq);
int gradient_organisation_init(ogi_t* des, ima3Du1 * ima);
int gradient_organisation_calc(ogi_t* des, ima3Du1 * imaIn,  ima3Du1 * imaOut);
int gradient_organisation_ferm(ogi_t* des);



/*pas de code aprs cette ligne*/
#endif
