/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************* haar_wavelet.h  ************************************/
/*                                                                             */
/* descripteurs et prototypes associes aux l'operateurs sur le calcul          */
/* des coefficients d'ondelette de Harr                                        */
/*                                                                             */
/*  Derniere modif : L. Valet, 23.12.2006                                      */
/* *****************************************************************************/
/*pas de code avant cette ligne */
#ifndef __haar_wavelet
#define __haar_wavelet


#include "volume.h"
#include "image.h"
#include "proto2D.h"


typedef struct{
  unsigned char scale; /*echelle de l'analyse (min 1)*/
} hw_coef_entire_image_t;


param* hw_coef_entire_image_lect(hw_coef_entire_image_t* des, param* ptp, char* debq);
int hw_coef_entire_image_init(hw_coef_entire_image_t* des, ima3Du1* imaIn, ima3Du1* imaOut);
int hw_coef_entire_image_calc(hw_coef_entire_image_t* des, ima3Du1* imaIn, ima3Du1* imaOut);




typedef struct{
  unsigned char scale; /*echelle de l'analyse (min 1)*/
  unsigned char win_x, win_y, win_z; /*dimension de la fenetre d'analyse (multiple de 2^n)*/
  unsigned char win_opt_x, win_opt_y, win_opt_z;
  unsigned char direction; /*quel secteur on etudie*/
  unsigned char feature; /*quel calcul on realise sur le secteur choisi*/
  float *densite; /*pour le calcul des densites*/
  ima3Du1* imaVal; /*image pour le stockage des valeurs de l'image sur la fenetre de calcul*/
  ima3Du1* imaCoef; /*image pour le stockage des coefs d'ondelettes calcules sur la fenetre*/
} hw_coef_on_window_t;

param* hw_coef_on_window_lect(hw_coef_on_window_t* des, param* ptp, char* debq);
int hw_coef_on_window_init(hw_coef_on_window_t* des, ima3Du1* imaIn, ima3Du1* imaOut);
int hw_coef_on_window_calc(hw_coef_on_window_t* des, ima3Du1* imaIn, ima3Du1* imaOut);
int hw_coef_on_window_ferm(hw_coef_on_window_t* des);


/*pas de code apres cette ligne*/
#endif
