/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __svm_learn
#define __svm_learn


#include "image.h"
#include "proto2D.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "classifier.h"
#include "format_learning_set_from_imau1.h"



/** si tout s'est bien pass */
#define NO_ERROR_SVMLEARN   0
/** si le processus d'excution de svm_learn n'a pas pu etre cre.
* Alors svm_learn n'est pas excut.*/
#define PID_NEGATIF_SVMLEARN  1
/** si le fichier qui doit etre rempli avec les donnes 
d'apprentissage ne peut pas etre cre ou cras. */
#define ERROR_OPENING_LEARN_FILE_SVMLEARN    2
/** si le fichier des donnes d'apprentissage
* n'a pas pu etre ferm. */
#define ERROR_CLOSING_LEARN_FILE_SVMLEARN   3
/** si il y a eu un problme de mmoire pour allouer
* la place des arguments */
#define ERROR_G_MALLOC_ARG_SVMLEARN     4



/**
   \ingroup svm*/
typedef struct{
/** Tableau de caratres permettant de stocker
les paramtres de svm_learn. */
  char arg_svm[200];
/** Pointeur sur entiers permettant de stocker
les labels +1 ou -1 pour les exemples et les contre
exemples (stratgies un contre tous). */
  int *label_plus1_moins1;
/** Le nombre d'arguments de l'excutable. */
  int nb_arg;
} svm_learn_t;



param *svm_learn_lect(
		      svm_learn_t *des_learn, 
		      param *ptp, 
		      char *debq
		      );


int svm_learn_init(
		   svm_learn_t *des_learn,
		   learning_set learn_data
		   );     


int svm_learn_calc(
		   svm_learn_t *des_learn, 
		   char *chemin_exec_svm_learn,
		   learning_set learn_data, 
		   int label_a_separer,
		   char *model_file
		   );


int svm_learn_ferm(
		   svm_learn_t *des_learn
		   );


/*pas de code aprs cette ligne*/
#endif
 
		 
		 
