/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* pas de code avant cette ligne*/
#ifndef __vect_symb
#define __vect_symb 
#include "proto2D.h"

typedef struct {
    long dimx;
    long dimy;  
    long dimz;
}dimensions;

/** descripteur pour l'oprateur de trac de vecteurs dans une image*/
typedef struct {
  char *nom_in; 
  char *nom_out;
  char *nom_vect;
  int size;
  int dir;
  short intensity;  
}vector_t;

typedef struct {
  float element1;
  float element2;
  float element3;
} eigenvector;

typedef struct {
  dimensions * dim;
  eigenvector * data;
}allEigenvectors;

param *vector_lect(vector_t *des, param *ptp, char *debq);

int vector_init(vector_t *des);     
int vector_calc(vector_t *des);     

/*pas de code aprs cette ligne */
#endif

