/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* pas de code avant cette ligne*/
#ifndef __volume
#define __volume

#include <stdio.h>

/* Definition des constantes */
#define ALL  0
#define ONE  1
#define MANY 2

#define DECAL_LGTRACE 4
#define DECAL_NBTRACE 8
#define DECAL_NBPLAN  12
#define DECAL_NBOCTET 36
#define DECAL_LGTETE  72

#define LVF_MAGIC_NUMBER 0x00000080
#define LVF_MAGIC_NUMBER_INV 0x80000000


/* dfinition des structures pour le 3D*/
typedef struct
{
    int dimx, dimy, dimz; 
    int lgtete, dept;
    short *** data;
}ima3Ds2;

typedef struct
{
  int dimx, dimy, dimz; 
  int lgtete, dept;
  unsigned char *** data;
  int sequence_number; /*section en cours de traitement*/
  int sequence_width; /*nombre de section de la squence*/
  FILE * f; /*descripteur de fichier pour la lecture squenciel*/
}ima3Du1;


typedef struct
{
    int dimx, dimy, dimz; 
    int lgtete, dept;
    unsigned int *** data;
}ima3Du4;

typedef struct
{
    int dimx, dimy, dimz; 
    int lgtete, dept;
    unsigned long int *** data;
}ima3Du8;

typedef struct
{
    int dimx, dimy, dimz; 
    int lgtete, dept;
    double *** data;
}ima3Dd;

/*dclaration des principales routines */
void lire_longueur_trace(FILE * fin, int * long_trace);
void ecr_longueur_trace( FILE * fout, int long_trace);
void lire_nb_trace(FILE * fin, int * nb_trace);
void ecr_nb_trace(FILE * fout, int nb_trace);
void lire_nb_plan( FILE * fin, int * nb_plan);
void ecr_nb_plan( FILE * fout, int nb_plan);
void lire_nb_octet(FILE * fin, int * nb_octet);
void ecr_nb_octet(FILE * fout, int  nb_octet);
void lire_longueur_entete(FILE * fin, int *long_entete);
void ecr_longueur_entete( FILE * fout, int long_entete);
void copie_entete( FILE *fin, FILE *fout, int nb_plan, int nb_octet);
FILE *lect_ima3Ds2(char * nomfich, ima3Ds2 * image, int type, ...);    
FILE *lect_ima3Du1(char * nomfich, ima3Du1 * image, int type, ...);
FILE *lect_ima3Dd(char * nomfich, ima3Dd * image, int type, ...);
void ecr_ima3Du1(char * nomfich, ima3Du1 *image);
void ecr_ima3Ds2(char * nomfich, ima3Ds2 *image);
void ecr_ima3Dd(char * nomfich, ima3Dd *image);
void liberer_ima3Ds2(ima3Ds2 * image);
void liberer_ima3Du1(ima3Du1 * image);
void liberer_ima3Dd(ima3Dd * image);
void allouer_ima3Du1(ima3Du1  * ImaOut);
void allouer_ima3Du4(ima3Du4  * ImaOut);
void allouer_ima3Du8(ima3Du8  * ImaOut);
void allouer_ima3Ds2(ima3Ds2 * ImaOut);
void allouer_ima3Dd(ima3Dd * ImaOut);


/*prototypes et constantes pour les fichiers 3D lvf (listic volume file/format)*/
int lect_volume_u1(char * nomfich, ima3Du1 * pt_image);
int write_volume_u1(char * nomfich, ima3Du1 * pt_image);

int copie_entete_ima3du1(ima3Du1 * ptImaSrc, ima3Du1 * ptImaDst);
int ecriture_entete_lvf( char * nomfich, ima3Du1 * pt_image);
int lecture_entete_lvf(char * nomfich, ima3Du1 * pt_image);
int lect_volume_u1_sequence_first(char * nomfich, ima3Du1 * pt_image, int sw);
int lect_volume_u1_sequence_next(ima3Du1 * pt_image);
int lect_volume_u1_sequence_previous(ima3Du1 * pt_image);
int lect_volume_u1_sequence_number(ima3Du1 * pt_image);
int write_part_of_volume_u1(char * nomfich, ima3Du1 * pt_image, 
			    unsigned int x1, unsigned int y1, unsigned int z1,
			    unsigned int x2, unsigned int y2, unsigned int z2);
int write_volume_u1_sequence_preparation( char * nomfich, ima3Du1 * pt_image, int nb_section_avant);
int write_volume_u1_sequence_next(ima3Du1 * pt_image);
int write_volume_u1_sequence_fermeture(ima3Du1 * pt_image, int nb_section_apres);



/*pas de code aprs cette ligne */
#endif
