/** 
\ingroup essai

messaiXX = u1 | etc : executable(s) associe(s) a l'operateur "essai" - programme type.\n
Entree : une image type XX = u1 | etc\n
Sortie : une image type XX = u1 | etc\n
Description : programme type illustrant la saisie de parametres 
et l'utilisation des operateurs read_ima, essai et write_ima.\n
Effectue une simple recopie de l'image entrante dans l'image sortante.

\author E. Trouve 
\version 1.0 (19/10/99)
\see lread_ima, lessai et lwrite_ima
*/
#include "image.h"    /* types des donnees manipulees dans ima2D */
#include "proto2D.h"  /* descripteurs et prototypes des fonctions de ima2D */
#include "essai.h"    /* complement pour les operateurs en cours de developpt */ 
#include <stdlib.h>


int main(int argc, char *argv[]){

/* DECLARATIONS */

  /* images */ 
  imau1 im0, imres;

  /* operateurs */
  read_ima_t rea;
  essai_t bid;
  write_ima_t wri;   

  /* main : variables et parametres propres au main*/
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  int iloc;              
  float floc;
  char  nomloc[200];

  
/* LECTURE PARAMETRES */

  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = read_ima_lect(&rea, ptp, ">> read_ima_lect, debut de question :");
  ptp = essai_lect(&bid, ptp, ">> essai_lect, debut de question :");
  ptp = write_ima_lect(&wri, ptp, ">> write_ima_lect, debut de question :");

  /* main : en cas de parametres lus dans le main */
  lec_param(">>main, entier iloc", ptp);
  iloc = atoi(ptp->rep);
  ptp = ptp->next;
  lec_param(">>main, float floc", ptp);
  floc = (float)atof(ptp->rep);
  ptp = ptp->next;
  lec_param(">>main, chaine de caracteres nomloc", ptp);
  strcpy(nomloc, ptp->rep);
  ptp = ptp->next;  

  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);


/* INITIALISATION  */

  /* operateur */
  read_imau1_init(&rea, &im0);
  essaiu1_init(&bid, im0, &imres);
  write_ima_init(&wri);

  /* main : en cas de variable a allouer/initialiser dans le main  */ 

   
/* CALCUL */
   essaiu1_calc(&bid, im0, &imres); 
   printf("\n partie calcul, iloc=%d, floc=%f, nomloc=%s\n", iloc, floc, nomloc);
  /* pas de read_imau1_calc, write_imau1_calc : lecture, ecriture en une fois */


/* FREMETURE */
  write_imau1_ferm(&wri, imres);
  
}

