/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/



#include <stdlib.h>



#define NO_ERROR 0




/*---------------------------------------------------
  Macros 
  ----------------------------------------------------*/

/* Macro pour afficher message */
#define ERREUR(message) \
  {\
    printf("\nERREUR --> fichier %s ligne %d : \n%s\n \n", __FILE__, __LINE__, message) ;\
    exit(1);\
  }\



/* Macro permettant de verifier si un pointeur pointe sur NULL 
et affiche chaine passee en param si oui */
#define VERIF_PT_NULL(PT, CHAINE)\
  if(PT == NULL)\
      {\
      printf("\nVerif_pt_null : le pointeur verifie a renvoye NULL \n");\
      ERREUR(CHAINE);\
    }\


/* Macro pour allouer : verifie si null et affiche mess si pb */
#define ALLOUER(PTR, NB, TYPE)	\
  {\
    PTR = (TYPE*)malloc ((NB) * sizeof(TYPE));	\
    VERIF_PT_NULL(PTR,"Allocation Impossible");\
    }\


/* macro pour calculer le carr d'un nombre */
#define MULTIPLIER(x,y) ((x)*(y))


/* valeur absolue */
#ifndef ABS
#define ABS(x) ( (x) > 0 ? x : -(x) )
#endif

