/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __svm_classify
#define __svm_classify


#include "image.h"
#include "proto2D.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "classifier.h"
#include "format_learning_set_from_imau1.h"

/** Si le calcul s'est bien pass */
#define NO_ERROR_SVMCLASSIFY    0
/** Si le fichier contenant les donnes
rsultats de la classification ne peut pas etre ouvert. */
#define ERROR_OPENING_OUTPUT_FILE_SVMCLASSIFY   1
/** si le processus d'excution de svm_classify n'a 
pas pu etre cre. Alors svm_classify n'est pas excut. */
#define PID_NEGATIF_SVMCLASSIFY    2
/** si le fichier qui doit etre rempli avec les donnes 
d'attributs ne peut pas etre cre ou cras. */
#define ERROR_OPENING_DATA_FILE_SVMCLASSIFY  3
/** si le fichier des donnes d'attributs
n'a pas pu etre ferm. */
#define ERROR_CLOSING_DATA_FILE_SVMCLASSIFY    4
/** si il y a eu un problme de mmoire pour allouer
la place des arguments. */
#define ERROR_G_MALLOC_ARG_SVMCLASSIFY   5
/** si l'indice de la structure data_output pass
en paramtre est suprieur au nombre de classes 
spcifis dans la structure data_output (devant etre 
pralablement alloue). */
#define INDICE_SUP_NBCLASS_SVMCLASSIFY   6
/** si le fichier contenant les donnes
rsultats de la classification ne peut etre ferm. */
#define ERROR_CLOSING_OUTPUT_FILE_SVMCLASSIFY  7


/** \ingroup svm */
typedef struct{
/** Tableau de caratres permettant de stocker
les paramtres de svm_classify. */
  char arg_svm[200];
/** Le nombre d'arguments de l'excutable. */
  int nb_arg;
} svm_classify_t;




param *svm_classify_lect(
		      svm_classify_t *des_classify, 
		      param *ptp, 
		      char *debq
		      );


int svm_classify_init(
		   svm_classify_t *des_classify
		   );     


int svm_classify_calc(
		   svm_classify_t *des_classify, 
		   char *chemin_svm_classify,
		   data_input dataIattributes,
		   char *model_file,
		   unsigned int indice,
		   data_output  *dataO
		   );

int svm_classify_ferm();

/*pas de code aprs cette ligne*/
#endif
 
		 
		 
