/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/

/* ********* traitement de donnes d'apprentissages  **************************/
/*                                                                            */
/*                                                                            */
/*                                                                            */
/*  Derniere modif : Lavinia DARLEA, 27/07/06                                 */
/* ****************************************************************************/

/* pas de code avant cette ligne*/
#ifndef __trait_donnes
#define __trait_donnes

#include "image.h"
#include "proto2D.h"
#include "format_learning_set_from_imau1.h"



//the variable type responsible for the rules and the quadrangles from which they were extracted
typedef struct { 
  char *fisin;
  char *fisout1;
  char *fisout2;
  int nb_class;
  int nb_attr;
  int *nb_pts;
  double lefrght[2][2];
  double updown[2][2];
  double slopes[4];
  double n[4];
  double func_app1[2][3];
  double func_app2[2][3];
} lgr_d;

//the chaining list that contains the points marked as belonging to the contour (not the convex hull!)
  typedef double pct;
  typedef struct elem_contour {
    pct x;
    pct y;
    struct elem_contour *next;
    struct elem_contour *ant;
  } elem_contour;


param *traitement_donnees_lect(lgr_d *a, param *ptp, char *debq);
int traitement_donnees_init(lgr_d a, learning_set *ls);     
int traitement_donnees_calc(learning_set ls, lgr_d a); 
    
float minim(float a, float b);
float dmin(learning_set ls, int pos_start, int pos_stop, int att);



/*pas de code apres cette ligne */
#endif
