/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* Programme de test : creation des DP et des DT */
/* Validation sur donnes simples provenant articles de Shipp/Kuncheva */




#include "image.h"
#include "proto2D.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "classifier.h"
#include "macros.h"



int main(int argc, char *argv[])
{
  FILE *fp = NULL;
  char nom[200], proto[200];
  int i;


  if(argc == 1)
    ERREUR("\nPas assez d'arguments : le nom de l'operateur doit etre specifie\n");
      
  if(argc>2)
    ERREUR("\nTrop d'arguments : le seul argument a specifier doit etre le nom de l'operateur\n");
  
  if(argv[1][0] == '-' )
    {
      if(argv[1][1] != '-' ) 
	{
	  ERREUR("1 : Option non reconnue : --h pour afficher l'aide\n");
	}
      
      else
	{
	  if(argv[1][2] == 'h')
	    {      
	      printf("\nCet executable permet de creer les fichiers d'un operateur xxx :\n");
	      printf("   -> un fichier lxxx.c \n   -> et un fichier xxx.h.\n");
	      printf("\nCes fichiers sont crees a partir de la chaine \"lxxx\" qui doit etre passee en argument.\n");
	      printf("\nLe fichier passe en argument doit ne doit pas posseder d'extension.\n");
	      printf("\nLe fichier passe en argument doit commencer par le caractere 'l'.\n\n");
	    
	      return 0;
	    }
	  else ERREUR("2 : Option non reconnue : --h pour afficher l'aide\n");
	}
    }

  
  if(argv[1][0] != 'l')
    ERREUR("Le nom de l'operateur doit etre precede du caractere 'l'\n");

  /* le nom de l'operateur est sans le 'l' */
  for(i=1;i<strlen(argv[1]);i++)
    {
      nom[i-1] = argv[1][i];
      if(argv[1][i] == '.')
	{
	  ERREUR("Le fichier passe en parametre ne doit pas avoir d'extension.\n");
	}
    }
  nom[i-1]='\0';
  
  /* le .h */
  strcpy(proto,nom);
  proto[strlen(nom)] = '\0';
  strcat(proto,".h");
  
  /* creer lope.c */
  strcat(argv[1],".c");
  VERIF_PT_NULL(argv[1],"La fonction strcat renvoie null\n");
  
  fp=fopen(argv[1],"w");

  VERIF_PT_NULL(fp,"Pointeur fichier null : probleme a l'ouverture du fichier de l'operateur (.c)");

  fprintf(fp,"/* -----------------------------------------------------------------------------------------------\n");

  fprintf(fp,"    Operateur : %s \n",nom);
  
  fprintf(fp,"   -----------------------------------------------------------------------------------------------\n");
  
  fprintf(fp,"   Objectif de l'operateur\n\n");

  fprintf(fp,"   Cet operateur a pour but de ............\n\n");

  fprintf(fp,"   -----------------------------------------------------------------------------------------------\n");
  
  fprintf(fp,"   Derniere modification le %s  a   %s \n",__DATE__,__TIME__);

  fprintf(fp,"   -----------------------------------------------------------------------------------------------\n");
  
  fprintf(fp,"   Cree par                      \n");

  fprintf(fp,"   -----------------------------------------------------------------------------------------------*/");

  fprintf(fp,"\n\n\n\n");
  
  fprintf(fp,"/** @name  %s\\n \n \n Cet ensemble de fonctions permet de ....  \n\n */ \n //@{ \n\n\n\n",nom);

  
  
  fprintf(fp,"/* Bibliotheques */\n");
  fprintf(fp,"#include <stdlib.h>\n");
  fprintf(fp,"#include \"%s\"\n",proto);
  fprintf(fp,"#include \"image.h\"\n");
  fprintf(fp,"#include \"proto2D.h\"\n");
  fprintf(fp,"\n\n\n");

  fprintf(fp,"/****************************  LECTURE ******************************** /\n");
  
  fprintf(fp,"/*! \\brief  Mettre une phrase de resume ou le debut de l'explication \n");
  fprintf(fp,"de la lecture de l'operateur \n");
  fprintf(fp,"Mettre la suite de l'explication ici...\n\n");

  fprintf(fp,"Lecture des parametres de l'operateur %s :\n\n",nom);
  
  fprintf(fp,"\\param desc pointeur descripteur \n");
  fprintf(fp,"\\param ptp pointeur sur parametre courant deja alloue (a lire)\n");  
  fprintf(fp,"\\param debq pointeur de chaine de caracteres placee en debut de question\n");
  fprintf(fp,"\\return renvoie nouveau pointeur de parametres deja alloue (pour la suite) \n");
  fprintf(fp,"\\author Nom Prenom\n");
  fprintf(fp,"\\version 1.0\n");
  fprintf(fp,"*/\n\n\n");

  
  fprintf(fp,"param *%s_lect(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					          param *ptp,  \n");
  fprintf(fp,"					          char *debq \n"); 
  fprintf(fp,"					          )\n"); 
  fprintf(fp,"{\n"); 
  fprintf(fp,"char question[500];\n");
  fprintf(fp,"\n\n\n");
  fprintf(fp,"return ptp;\n");
  fprintf(fp,"\n}\n\n\n");


  
   fprintf(fp,"/****************************  INIT ******************************** /\n");
  
  fprintf(fp,"/*! \\brief  Mettre une phrase de resume ou le debut de l'explication \n de l'initialisation de l'operateur \n");

  fprintf(fp,"Initialisation des parametres de l'operateur %s :\n",nom);
  
  fprintf(fp,"\\param desc pointeur descripteur \n");
  fprintf(fp,"\\param   .........\n");  
  fprintf(fp,"\\param   .........\n");
  fprintf(fp,"\\return une des constantes definie dans le .h suivant erreur rencontree \n");
  fprintf(fp,"\\author Nom Prenom\n");
  fprintf(fp,"\\version 1.0\n");
  fprintf(fp,"*/\n\n\n");

  
  fprintf(fp,"int %s_init(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					                \n"); 
  fprintf(fp,"					          )\n"); 
  fprintf(fp,"{\n"); 
  
  fprintf(fp,"\n\n\n");
  fprintf(fp,"return NO_ERROR;\n");
  fprintf(fp,"\n}\n\n\n");



  
   fprintf(fp,"/****************************  CALC******************************** /\n");
  
  fprintf(fp,"/*! \\brief  Mettre une phrase de resume ou le debut de l'explication \n du calcul de l'operateur \n");

  fprintf(fp,"Calcul de l'operateur %s :\n",nom);
  
  fprintf(fp,"\\param desc pointeur descripteur \n");
  fprintf(fp,"\\param   .........\n");  
  fprintf(fp,"\\param   .........\n");
  fprintf(fp,"\\param  resultat de type pointeur sur  .........\n");
  fprintf(fp,"\\return une des constantes definie dans le .h suivant erreur rencontree \n");
  fprintf(fp,"\\author Nom Prenom\n");
  fprintf(fp,"\\version 1.0\n");
  fprintf(fp,"*/\n\n\n");

  
  fprintf(fp,"int %s_calc(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					                \n"); 
  fprintf(fp,"					          )\n"); 
  fprintf(fp,"{\n"); 
  
  fprintf(fp,"\n\n\n");
  fprintf(fp,"return NO_ERROR;\n");
  fprintf(fp,"\n}\n\n\n");


  
   fprintf(fp,"/****************************  FERM ******************************** /\n");
  
  fprintf(fp,"/*! \\brief  Mettre une phrase de resume ou le debut de l'explication \n de la fermeture de l'operateur \n");

  fprintf(fp,"Liberation de la memoire allouee pour les parametres de l'operateur %s :\n",nom);
  
  fprintf(fp,"\\param desc pointeur descripteur \n");
  fprintf(fp,"\\return une des constantes definie dans le .h suivant erreur rencontree \n");
  fprintf(fp,"\\author Nom Prenom\n");
  fprintf(fp,"\\version 1.0\n");
  fprintf(fp,"*/\n\n\n");

  
  fprintf(fp,"int %s_ferm(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					          )\n"); 
  fprintf(fp,"{\n"); 
  
  fprintf(fp,"\n\n\n");
  fprintf(fp,"return NO_ERROR;\n");
  fprintf(fp,"\n}\n\n\n");
  
  
  fprintf(fp,"/* fin doc */\n");
  fprintf(fp,"//@}\n\n");
  
  if(fclose(fp))
    ERREUR("Impossible de fermer la fichier de l'operateur (.c)");

  printf("Le fichier  --- %s --- a ete cree\n",argv[1]);
  




  
  VERIF_PT_NULL(proto,"La fonction strcat renvoie null\n");
  
  fp=fopen(proto,"w");

  VERIF_PT_NULL(fp,"Pointeur fichier null : probleme a l'ouverture du fichier de l'operateur (.h)");

  fprintf(fp,"/* -----------------------------------------------------------------------------------------------\n");

  fprintf(fp,"    Operateur : %s \n",nom);
  
  fprintf(fp,"   -----------------------------------------------------------------------------------------------\n");
  
  fprintf(fp,"   Fichier des prototypes des fonctions de l'operateur\n\n");

  fprintf(fp,"   -----------------------------------------------------------------------------------------------\n");
  
  fprintf(fp,"   Derniere modification le %s  a   %s \n",__DATE__,__TIME__);

  fprintf(fp,"   -----------------------------------------------------------------------------------------------\n");
  
  fprintf(fp,"   Cree par                      \n");

  fprintf(fp,"   -----------------------------------------------------------------------------------------------*/");

  fprintf(fp,"\n\n\n\n");

  
  fprintf(fp,"/* Pas de code avant cette ligne */\n");
  fprintf(fp,"#ifndef __%s\n",nom);
  fprintf(fp,"#define __%s\n",nom);
  fprintf(fp,"\n\n\n\n");
  

  fprintf(fp,"/* Bibliotheques */\n");
  fprintf(fp,"#include <stdlib.h>\n");
  fprintf(fp,"#include \"image.h\"\n");
  fprintf(fp,"#include \"proto2D.h\"\n");
  fprintf(fp,"\n\n\n\n");

  fprintf(fp,"/* La doc a extraire doit etre dans  /**   ....     */  //(2 *)\n");
  fprintf(fp,"\n\n\n\n");


  fprintf(fp,"/* Descripteur */\n");
  fprintf(fp,"typedef struct{\n\n");
  fprintf(fp,"/** champ 1 : ........ */\n");
  fprintf(fp,"/** champ 2 : ........ */\n");
  fprintf(fp,"/** champ 3 : ........ */\n");
  fprintf(fp,"\n}%s_t;",nom);
  fprintf(fp,"\n\n\n\n");
 

  fprintf(fp,"/*  Lecture  */\n\n");
  fprintf(fp,"param *%s_lect(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					          param *ptp,  \n");
  fprintf(fp,"					          char *debq \n"); 
  fprintf(fp,"					          );\n"); 
  fprintf(fp,"\n\n\n");


  fprintf(fp,"/*  Initialisation  */\n\n");
  fprintf(fp,"int %s_init(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					               \n"); 
  fprintf(fp,"					          );\n"); 
  fprintf(fp,"\n\n\n");

  fprintf(fp,"/*  Calcul  */\n\n");
  fprintf(fp,"int %s_calc(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					                \n"); 
  fprintf(fp,"					          );\n"); 
  fprintf(fp,"\n\n\n");
  
  fprintf(fp,"/*  Fermeture  */\n\n");
  fprintf(fp,"int %s_ferm(\n",nom);
  fprintf(fp,"					          %s_t *desc,  \n",nom);
  fprintf(fp,"					          );\n"); 
  fprintf(fp,"\n\n\n");

  
  fprintf(fp,"/* Pas de code apres cette ligne */\n");
  fprintf(fp,"#endif\n");
  

  if(fclose(fp))
    ERREUR("Impossible de fermer la fichier de l'operateur (.h)");

  printf("Le fichier  --- %s --- a ete cree\n",proto);
  
  printf("Fin.\n");
}

  

      
