/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef _confusion_matrix
#define _confusion_matrix
#include <stdio.h>
#include "image.h"
#include "proto2D.h"
#include "classifier.h"
#include "volume.h"
#include "choquet.h"


//Descripteur de l'opérateur attributes_to_satisfaction
typedef struct{
  int nb_region_etudiee;
  int num_coupe;
  int type_eval;
  ima3Du1 imadec;
  ima3Du1 imaeval_3D;
  imau1 imaeval_2D;
  read_ima_t read_ima;
}confusion_matrix_t;

//fonction de lecture
param *confusion_matrix_lect(confusion_matrix_t *desc, param *ptp, char *debq);

//fonction d'initialisation
void confusion_matrix_init(confusion_matrix_t *desc);

//Fonction de calcul
void confusion_matrix_calc(confusion_matrix_t *desc,  int **matrice);



//Fonction de fermeture

void confusion_matrix_ferm(confusion_matrix_t *desc);


#endif
