/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/

/* pas de code avant cette ligne*/
#ifndef __distance_ima
#define __distance_ima

/** \ingroup distance_imau1
    descripteur pour l'oprateur de calcul de la carte de distance sur une image de type u1*/
typedef struct {
    float l;       /**< longueur du pixel*/
    int n;         /**< coefficient d'arrondi*/
} image_distance_t;

param *distance_imau1_lect(image_distance_t *des, param *ptp, char *debq);
int distance_imau1_init(image_distance_t *des, imau1 *imO, imau1 *imRes);     
int distance_imau1_calc(image_distance_t *des, imau1 *imO, imau1 *imRes);     

/*pas de code aprs cette ligne */
#endif
