/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************* histo.h  **********************************/
/*                                                                     */
/*      descripteurs et prototypes associes a l'operateur bidon        */
/*                                                                     */
/*  Derniere modif : F. Bujor E. Trouve                                */
/* *********************************************************************/

/* pas de code avant cette ligne*/
#ifndef __histo
#define __histo

/** \ingroup histo
    Descripteur pour le calcul des histogrammes*/
typedef struct histo_st{
    int bins;            /**< nombre de intervalles pour histograme */  
    FILE *pfd;           /**< pointeur fichier histograme */
    char nomhist[200];   /**< nom complet du fichier */
    unsigned int *h;     /**< tableau histogram */
    float min;           /**< valeur minimale pour histograme */
    float max;           /**< valeur maximale pour histograme */
    float step;          /**< valeur pas pour interval*/
    int ngm;             /**< niveau de gris du masque [0, 255] ou -1 (pas de masque)*/
} histo_t;

param *histo_lect(histo_t *des, param *ptp, char *debq);

int histofl_init(histo_t *des, imafl im0, imau1 mas);     
int histofl_calc(histo_t *des, imafl im0, imau1 mas);     

int histou1_init(histo_t *des, imau1 im0, imau1 mas);     
int histou1_calc(histo_t *des, imau1 im0, imau1 mas);     

int histou2_init(histo_t *des, imau2 im0, imau1 mas);     
int histou2_calc(histo_t *des, imau2 im0, imau1 mas);     

int histo_ferm(histo_t *des);


/*pas de code aprs cette ligne */
#endif
