/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/**\file image.h*/

/* *****************************image.h**********************************/
/*                                                                      */
/* Types des pixels, des images et autres structures de base de ima2D.h */
/*                                                                      */
/*  Derniere modif : L. VALET, 10/12/99                                */
/* **********************************************************************/

/*pas de code avant cette ligne*/
#ifndef __image
#define __image

#include <stdio.h>

/* image entiers 8 bits	non-signees */

/** definition d'un pixel */
typedef unsigned char pixu1;

/** une image est definie comme un ensemble de pixel
    doc longue
*/
typedef struct {				
  pixu1  **p; /**< pointeur vers les donnes de l'images*/
  int   nc;	/**< nbr of columns */
  int	nr;	/**< nbr of rows	  */
  char  nom[200];   /**< name      */
  pixu1 *lutr;  /**< palette rouge */
  pixu1 *lutv;  /**< palette vert */
  pixu1 *lutb;  /**< palette bleu */
} imau1;


/** image couleur 3 plans 8 bits	non-signes */
typedef  struct {				
    pixu1  **r, **v, **b;
    int   nc;	/**< nbr of columns */
    int	  nr;	/**< nbr of rows	  */
    char  nom[200];   /**< name      */
}imarvb;


/**  entiers 16 bits non-signes */
typedef unsigned short pixu2;


/**  image entiers 16 bits non-signes */
typedef struct {				
    pixu2 **p;
    int   nc;	/**< nbr of columns */
    int	  nr;	/**< nbr of rows	  */
    char  nom[200];   /**< name     */
}imau2;


/** entiers 16 bits signes */
typedef short pixs2;

/** image entiers 16 bits signes */
typedef struct {				
    pixs2 **p;
    int   nc;	/**< nbr of columns */
    int	  nr;	/**< nbr of rows	  */
    char  nom[200];   /**< name     */
}imas2;


/**  entiers 32 bits non-signes  */
typedef unsigned int pixu4;

/** image entiers 32 bits non-signes  */
typedef struct {				
    pixu4  **p;
    int  nc;	/**< nbr of columns */
    int	 nr;	/**< nbr of rows	  */
    char nom[200];   /**< name      */
}imau4;


/** entiers 32 bits signes (int) */
typedef int pixs4;

/** image entiers 32 bits signes (int) */
typedef struct {				
    pixs4  **p;
    int  nc;	/**< nbr of columns */
    int	 nr;	/**< nbr of rows	  */
    char nom[200];   /**< name      */
}imas4;


/** pixel de type float	*/
typedef float pixfl;

/** image de type float*/
typedef struct {				
    pixfl **p;
    int   nc;	/**< nbr of columns 	*/
    int	  nr;	/**< nbr of rows		*/
    char nom[200];   /**< name      */
}imafl;


/** pixel de type double */
typedef double pixdb;

/** image de type double */
typedef struct {		       
    pixdb  **p;
    int     nc;	/**< nbr of columns 	*/
    int	    nr;	/**< nbr of rows		*/
    char nom[200];   /**< name      */
}imadb;


/** nombre complexe short */
typedef struct  {
     short re;
     short im;
}pixcx4;


/** image complexe short */
typedef struct  {		       
    pixcx4  **p;
    int     nc;	/**< nbr of columns 	*/
    int	    nr;	/**< nbr of rows		*/
    char nom[200];   /**< name      */
}imacx4;


/** nombre complexe float */
typedef struct  {
     float re;
     float im;
}pixcx8;


/** image complexe float */
typedef struct  {		       
    pixcx8  **p;
    int     nc;	/**< nbr of columns 	*/
    int	    nr;	/**< nbr of rows		*/
    char nom[200];   /**< name      */
}imacx8;


/** nombre complexe double */
typedef struct  {
     double re;
     double im;
}pixcx16;


/** image complexe double */
typedef struct  {		       
    pixcx16 **p;
    int     nc;	/**< nbr of columns 	*/
    int	    nr;	/**< nbr of rows		*/
    char nom[200];   /**< name      */
}imacx16;



/** parametre */
struct parametre{
    char qst[200];  /**< question  */
    char rep[200];  /**< reponse   */
    struct parametre *next;
};

/** param*/
typedef struct parametre param;


/*pas de code apres cette ligne*/
#endif
