/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ********************** indexed_img.h ******************************  */
/*                                                                      */
/*      descripteurs et prototypes associes a l'operateur indexed_img   */
/*                                                                      */
/*  Derniere modif : B. IONESCU, 15/05/00                               */
/* ******************************************************************** */

#include "image.h"
#include "proto2D.h"
#include "rasterfile.h"
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <math.h>

/** \ingroup indexed_img
    descripteur pour l'oprateur   indexed_img*/
typedef struct {
    int nrcouches;
    int nrepochs;
    imadb Dist;
    imadb TrainingData;
    imadb Weight1;
    imadb Weight2;
    imau1 T;
} kohonenstruct;

param *indexed_img_lect(kohonenstruct *des, param *ptp, char *debq);
int indexed_img_init(kohonenstruct *des, imarvb im0, imau1 *imres);
int indexed_img_calc(kohonenstruct *des, imarvb im0, imau1 *imres);

int alloc_lut_u12(imau1 *im);
int free_lut_u12(imau1 *im1);



