/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************* labelcc.h  **********************************/
/*                                                                     */
/*      descripteurs et prototypes associes a l'operateur labelcc        */
/*                                                                     */
/*  Derniere modif : E. TROUVE, 18/10/99                               */
/* *********************************************************************/

/* pas de code avant cette ligne*/
#ifndef __labelcc
#define __labelcc

/** \ingroup labelcc
    Descripteur de l'oprateur labelcc*/
typedef struct{
    int connex;    /**< connexite 4 ou 8  */
    int seuil;     /**< seuil de demarage des niveaux de gris des objets */
    int contraste;  /**< <0 pour objets sombres, >=0 pour objets claires */ 
} labelcc_t;

param *labelcc_lect(labelcc_t *des, param *ptp, char *debq);
int labelccu1_init(labelcc_t *des, imau1 im0, imau2 *imres);     
int labelccu1_calc(labelcc_t *des, imau1 im0, imau2 *imres);     

/*pas de code aprs cette ligne */
#endif


