/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file reggrow.h */

/* *************************reggrow.h  ***********************************/
/*                                                                       */
/* descripteurs et prototypes associes a l'operateur croissance de regions*/
/*                                                                       */
/*  Derniere modif : G. Marinescu, 29.04.03                              */
/* ***********************************************************************/
/*pas de code avant cette ligne */
#ifndef __reggrow
#define __reggrow


#include "image.h"
#include "proto2D.h"


/**  \ingroup reggrow 
     Dfinition d'un type contenant l'ensemble des informations
     pour l'oprateur de segmentation bas sur la croissance de rgion
*/
typedef struct {   
  int 	nb_loop;      	/**< nombre iterations */
  int	seuil0;		/**< seuil de depart pour l'aggregation de 2 regions */
  int 	step;		/**< increment du seuil */
  int 	taille;		/**< taille minimum d'une region */
} reggrow_t;



// Prototype des fonctions utilises
param* reggrow_lect(reggrow_t* reg, param* ptp, char* debq);
int reggrow_init(reggrow_t* reg, imau1 *im0, imau1* imres);
int reggrow_calc(reggrow_t* reg, imau1 *im0, imau1* imres);      



/*pas de code aprs cette ligne*/
#endif
