/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include "image.h"
#include "proto2D.h"
#include "classifier.h"
#include "confusion_matrix.h"

main(int argc, char *argv[])
{
  int i,j,k,r;
  int x,y,z;
  int somme;
  float taux;
  char question[500];

  param par0, *ptp;

  //char fich[20];
  confusion_matrix_t *desc;
  int **matrice;


 

  /* ************************ LECTURE PARAMETRES************************* */

  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0);
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  desc=(confusion_matrix_t *)malloc(sizeof(confusion_matrix_t));

  ptp=confusion_matrix_lect(desc, ptp, " ");



  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);



  /* ***************************INITIALISATION************************* */


  confusion_matrix_init(desc);

  printf("Init OK\n");

  matrice=(int **)malloc((desc->nb_region_etudiee+1)*sizeof(int *));
  for(i=0;i<(desc->nb_region_etudiee+1);i++)
    matrice[i]=(int *)malloc((desc->nb_region_etudiee+1)*sizeof(int ));


 for(i=0;i<(desc->nb_region_etudiee+1);i++)
     for(j=0;j<(desc->nb_region_etudiee+1);j++)
       matrice[i][j]=0;
       
  /* ***************************************CALCUL**************************** */


  confusion_matrix_calc(desc, matrice);

  for(j=0;j<(desc->nb_region_etudiee+1);j++)
    printf("R%d\t",j);

  printf("\n");

 for(i=1;i<(desc->nb_region_etudiee+1);i++)
   {
     for(j=0;j<(desc->nb_region_etudiee+1);j++)
       printf("%d\t",matrice[i][j]);

     printf("R%d\n",i);
   }

  somme=0;
  for(i=0;i<(desc->nb_region_etudiee+1);i++)
     for(j=0;j<(desc->nb_region_etudiee+1);j++)
       somme=somme+matrice[i][j];
  
 taux=0.0;
 for(i=1;i<(desc->nb_region_etudiee+1);i++)
   taux=taux+((float)matrice[i][i])/somme;

  printf("Taux de bonne classification: %3.2f %\n",taux*100);

 taux=0.0;
 for(i=1;i<(desc->nb_region_etudiee+1);i++)
   taux=taux+((float)matrice[i][0])/somme;


  printf("Taux de rejet: %3.2f %\n",taux*100.0);


  for(i=1;i<desc->nb_region_etudiee+1;i++)
    {
      somme=0;
      for(j=0;j<desc->nb_region_etudiee+1;j++)
	somme=somme+matrice[i][j];

      printf("Rappel de la classe R%d: %3.2f %\n",i,100*((float)matrice[i][i]/somme));

    }

  for(i=1;i<desc->nb_region_etudiee+1;i++)
    {
      somme=0;
      for(j=1;j<desc->nb_region_etudiee+1;j++)
	somme=somme+matrice[j][i];

      printf("Precision de la classe R%d: %3.2f %\n",i,100*((float)matrice[i][i]/somme));

    }


  //Fermeture
  confusion_matrix_ferm(desc);

  for(i=0;i<(desc->nb_region_etudiee+1);i++)
    free(matrice[i]);
  free(matrice);

  free(desc);
  
  //free(desc);
}
