/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** executable associe  l'oprateur sur le calcul de l'image de distance,  partir d'une image binaire 8 bist.\\
Entree : imau1 (8 bits)\\
Sortie : imau1 (8 bits)\\
@name mdistance_imau1
@author L. VALET
@version 1.0 (02/12/99)
@see ldistance_ima
*/

#include "volume.h"
#include "image.h"
#include "proto2D.h"
#include "distance_ima.h"    /* complement pour les operateurs en cours de developpt */ 

int main(int argc, char *argv[]){

/* DECLARATIONS */


  /* operateurs */
  read_ima_t ri;  
  image_distance_t dist;
  write_ima_t wi;
  imau1 in, out;

  /* main : variables et parametres propres au main*/
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */

  
/* LECTURE PARAMETRES */

  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = read_ima_lect( &ri, ptp, "");
  ptp = distance_imau1_lect( &dist, ptp, "");
  ptp = write_ima_lect (&wi, ptp, "");
 
  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);


  /* INITIALISATION  */
  read_imau1_init( &ri, &in);
  distance_imau1_init( &dist, &in, &out);
  write_ima_init( &wi); 

   
  /* CALCUL */
  distance_imau1_calc(&dist, &in, &out );
  write_imau1_ferm( &wi, out); 
  printf("FIN\n");

  free_imau1(&in);
  free_imau1(&out);
}

