/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** executable associe a l'operateur "labelcc" : etiquetage en composantes 4 ou 8 connexes.\\
Entree : une image type u1 \\
Sortie : une image type u1/u2 selon extension : fond a 0, label sur 8 ou 16 bits \\
Description : cf. llabelcc.c \\
@name mlabelcc_u1
@author E. Trouve (code de Michel Roux, ENST)
@version 1.0 (09/06/00)
@see lread_ima, llabelcc et lwrite_ima
*/
#include "image.h"    /* types des donnees manipulees dans ima2D */
#include "proto2D.h"  /* descripteurs et prototypes des fonctions de ima2D */
#include "labelcc.h"  /* complement pour l'operateur  labelcc */ 
#include <stdlib.h>


int main(int argc, char *argv[]){
  int i, j;
  int tmp;

/* DECLARATIONS */
  /* images */ 
  imau1 im0;
  imau2 imres;
  imau1 imresu1;
  /* operateurs */
  read_ima_t rea;
  labelcc_t lab;
  write_ima_t wri1;

  param par0, *ptp;

/* LECTURE PARAMETRES */
  param_debut(argc, argv, &par0); 
  ptp = &par0;  
  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = read_ima_lect(&rea, ptp, ">> image initiale (u1):");
  ptp = labelcc_lect(&lab, ptp, ">> etiquetage :");
  ptp = write_ima_lect(&wri1, ptp, ">> image resultat, labels (u1/u2) :");
  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);

/* INITIALISATION  */
  /* operateur */
  read_imau1_init(&rea, &im0);
  labelccu1_init(&lab, im0, &imres);
  write_ima_init(&wri1);

/* CALCUL */
   labelccu1_calc(&lab, im0, &imres);
   if(strcmp(wri1.ext, "ima") == 0 || strcmp(wri1.ext, "ras") == 0){
       imresu1.nr = imres.nr;
       imresu1.nc = imres.nc;
       alloc_imau1(&imresu1);
       for(j=0; j<imres.nr; j++)
	   for(i=0; i<imres.nc; i++){
		if ( (tmp=(int)(imres.p[j][i])) < 256 )
			imresu1.p[j][i] = (pixu1)tmp;
		else{
			tmp = tmp%255;
			tmp++;
			imresu1.p[j][i] = (pixu1)tmp;
		}
	   }
   }
       
/* FREMETURE */
   if(strcmp(wri1.ext, "ima") == 0 || strcmp(wri1.ext, "ras") == 0)
       write_imau1_ferm(&wri1, imresu1);
   else
       write_imau2_ferm(&wri1, imres);
   
}

