/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** XX = u1 : executable(s) associe(s) a l'operateur "median".\\
Entree : une image type XX = u1\\
Sortie : une image type XX = u1\\
Description :TRAITEMENT BIDIMENSIONNEL (D'UNE IMAGE) PAR LA METHODE DE L'HISTOGRAMME
             AVEC UNE FENETRE RECTANGULAIRE (TRAITEMENT NON SEPARABLE)
@name mmedhist
@author G. Marinescu 
@version 1 (01.04.03)
@see lread_ima, lessai et lwrite_ima
*/

#include <stdio.h>
#include <math.h>
#include "image.h"
#include "proto2D.h"
#include "rasterfile.h"
#include "medhist.h"




/*-----------------------------------------------------------*/
/*                          PRINCIPAL                        */                        
/*-----------------------------------------------------------*/
int main (int argc, char *argv[])
{
  /* DECLARATIONS */
  int tf;
  imau1 im0, imres;
  param par0, *ptp; 
  read_ima_t rea;
  write_ima_t wri;
  median_hist_t mask;

  /* LECTURE PARAMETRES */
  param_debut(argc, argv, &par0);
  ptp = &par0;
  ptp = read_ima_lect(&rea, ptp, ">> image initiale  (u1) :");
  ptp = write_ima_lect(&wri, ptp, ">> image resultat  (u1) :");
  lec_param(">>taille de la fenetre:", ptp); 
  mask.tf= atoi(ptp->rep);
  ptp = ptp->next;
  param_fin(argc, argv, &par0);
  /* INITIALISATION  */
  read_imau1_init(&rea, &im0);
  write_ima_init(&wri);
  /* CALCUL */
  medhist_calc(&mask, im0, &imres);

  /* FREMETURE */
  write_imau1_ferm(&wri, imres);

}
 

