/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** executable moyenne 2D glissante, image 8 bit (u1), 16 bit (u2) ou float (fl).\\
Entree : image 8 bit (u1), 16 bit (u2) ou float (fl).\\
Sortie : image moyennee du meme type, \\
@name mmoy2D
@author E. Trouve
@version 1.0 (14/09/00)
@see lmoy2D
*/

#include "image.h"
#include "proto2D.h"

int main(int argc, char *argv[]){
  /* images */ 
  imau1 im0u1, moyampu1;          
  imau2 im0u2, moyampu2;          
  imafl im0fl, moyampfl;          
  /* operateurs */
  read_ima_t  rea;
  moy2D_t     moy;
  write_ima_t wri;
 /* main : variables et parametres propres au main*/
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  int t0;

/* LECTURE PARAMETRES */
  param_debut(argc, argv, &par0); 
  ptp = &par0;
  ptp = read_ima_lect(&rea, ptp, ">> image initiale (u1|u2|fl) :");
  ptp = write_ima_lect(&wri, ptp, ">> image resultat(meme type) :");
  ptp = moy2D_lect(&moy, ptp, ">> fenetre de moyennage :");
  param_fin(argc, argv, &par0);

/* INITIALISATION  */
 if( !strcmp(rea.ext, "ima") || !strcmp(rea.ext, "ras")){
      t0 = 1;
      read_imau1_init(&rea, &im0u1);  
      moy2Du1_init(&moy, im0u1, &moyampu1);
  }
  else if(!strcmp(rea.ext, "imw")){
      t0 = 2;
      read_imau2_init(&rea, &im0u2);
      moy2Du2_init(&moy, im0u2, &moyampu2);
  }
  else if(!strcmp(rea.ext, "imf")){
      t0 = 4;
      read_imafl_init(&rea, &im0fl);
      moy2Dfl_init(&moy, im0fl, &moyampfl);
  }
  else{
      printf("\n>>moy2D ERREUR : extension %s inconnue\n", rea.ext);
      exit(0);
  }
  write_ima_init(&wri);
 
/* CALCUL */
  switch(t0){
  case 1 :	
      moy2Du1_calc(&moy, im0u1, &moyampu1);
      break;
  case 2 :
      moy2Du2_calc(&moy, im0u2, &moyampu2);
      break;
  case 4 :
      moy2Dfl_calc(&moy, im0fl, &moyampfl);
      break;
  }
  
/* FREMETURE */
  switch(t0){
  case 1 :	
      write_imau1_ferm(&wri, moyampu1);
      break;
  case 2 :	
      write_imau2_ferm(&wri, moyampu2);
      break;
  case 4 :	
      write_imafl_ferm(&wri, moyampfl);
      break;
  }
}



