/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** XX = u1 : executable segmentation d'une image 2D.\\
Entree : image de type XX = u1 \\
Sortie : meme type\\
@name mreggrow.c
@author G. Marinescu, L. Valet
@version 1.0 (29/04/03)
@see
*/

#include "image.h"
#include "proto2D.h"
#include "reggrow.h"

int main(int argc, char *argv[]){
  /* images */ 
  imau1 im0, imres; 
  int r;
  /* operateurs */
  read_ima_t  rea;
  reggrow_t regparam;
  write_ima_t wri;
 /* main : variables et parametres propres au main*/
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
 

/* LECTURE PARAMETRES */
  param_debut(argc, argv, &par0); 
  ptp = &par0;
  ptp = reggrow_lect(&regparam, ptp, ">>region growing question :");
  ptp = read_ima_lect(&rea, ptp, ">> image initiale 1 (u1) :");
  ptp = write_ima_lect(&wri, ptp, ">> image resultat 1 (u1) :");

  param_fin(argc, argv, &par0);

/* INITIALISATION  */
  read_imau1_init(&rea, &im0);
  reggrow_init(&regparam, &im0, &imres);
  write_ima_init(&wri);

/* CALCUL */
  reggrow_calc(&regparam, &im0, &imres);
  
/* FERMETURE */
  write_imau1_ferm(&wri, imres);
  return(0);
}



