/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************** mselect_cx4.c *******************************/
/*                                                                        */
/*       SELECTION DE DONNEES DE TYPE CX4 (complexe entier 2x16 bit)      */
/*               LECTURE ET ECRITRE BLOC PAR BLOC                         */
/*                                                                        */
/*  Derniere modif : E. TROUVE, 06/03/2000                                */
/* ************************************************************************/

#include "image.h"
#include "proto2D.h"  /* descripteurs et prototypes des fonctions de ima2D */
#include <stdlib.h>

int main(int argc, char *argv[]){
/* DECLARATIONS */
  /* images */ 
  imacx4 bl0;          
  /* operateurs */
  select_ima_t  sel;
  save_ima_t sav;
  /* local */
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  int j;

/* LECTURE PARAMETRES */
  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = select_ima_lect(&sel, ptp, "image initiale (cx4) :");
  ptp = save_ima_lect(&sav, ptp, "image resultat (cx4) :");

  /* main : en cas de parametres lus dans le main */

  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);


/* INITIALISATION  */
  select_imacx4_init(&sel, &bl0);
  save_ima_init(&sav);


/* CALCUL */
  while(select_imacx4_calc(&sel, &bl0)==0){
      save_imacx4_calc(&sav, bl0);
  }

  
/* FREMETURE */
  save_ima_ferm(sel, sav);
}



