/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* ************************** mselect_u1.c ********************************/
/*                                                                        */
/* ************************************************************************/

/** XX = u1 | u2 | fl | cx4 | cx8 : executables de decoupage avec lectrure/ecriture bloc par bloc.\\
Entree : une image type XX = u1 | u2 | fl | cx4 | cx8  \\
Sortie : une image de meme type\\
Description : lecture / ecriture iterative de blocs de lignes d'une image par les operteurs select_ima et save_ima\\
Optionel (cf. parametre legende) : creation d'un fichier .oigima avec les coordonnee de la zone selectionee\\
@name mselect_XX
@author E. Trouve 
@version 1.0 (15/03/2000)
@see lselect_ima et lsave_ima
*/

#include "image.h"
#include "proto2D.h"  /* descripteurs et prototypes des fonctions de ima2D */
#include <stdlib.h>

int main(int argc, char *argv[]){
/* DECLARATIONS */
  /* images */ 
  imau1 bl0;          
  /* operateurs */
  select_ima_t  sel;
  save_ima_t sav;
  /* local */
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  int j;

/* LECTURE PARAMETRES */
  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = select_ima_lect(&sel, ptp, "image initiale (u1) :");
  ptp = save_ima_lect(&sav, ptp, "image resultat (u1) :");

  /* main : en cas de parametres lus dans le main */

  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);


/* INITIALISATION  */
  select_imau1_init(&sel, &bl0);
  save_imau1_init(&sav, bl0);


/* CALCUL */
  while(select_imau1_calc(&sel, &bl0)==0){
      save_imau1_calc(&sav, bl0);
  }

  
/* FREMETURE */
  save_ima_ferm(sel, sav);
}



