/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/* *************************median.h  *****************************************/
/*                                                                             */
/* descripteurs et prototypes associes a l'operateur de croissance de rgion   */
/*                                                                             */
/*  Derniere modif : L. Valet, 13.12.2004                                      */
/* *****************************************************************************/
/*pas de code avant cette ligne */
#ifndef __reggr3d
#define __reggr3d

#include "volume.h"   /* descripteurs et prototypes des fonctions de ima3D */
#include "image.h"
#include "proto2D.h"

//#define false 0
//#define true 1



typedef struct{
  unsigned char nb_loop;
  unsigned char seuil0;
  unsigned char step;
  unsigned long int nb_etiq; /*nombre d'tiquettes utilises dans l'algorithme*/
  unsigned long int nb_label; /* Nombre de labels effectifs obtenus apres simplification des tiquettes*/
} reggr3d_t;


/* Prototype des fonctions utilises dans lreggr3d.c*/
param* reggr3d_lect(reggr3d_t* des, param* ptp, char* debq);
int reggr3d_init(reggr3d_t* des, ima3Du1* im0, ima3Du4* imres);
int reggr3d_calc(reggr3d_t* des, ima3Du1* im0, ima3Du4* imres);      




/*pas de code aprs cette ligne*/
#endif
