/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** XX = u1 : executable(s) associe(s) a l'operateur "M_coocur".\\
Entree : une image type XX = u1\\
Sortie : une image type XX = u1\\
Description : Programme realisant la matrice de coocurance
@name mM_coocur
@author G. Selaru
@version 1 (15.05.05)
@see lread_ima, lessai et lwrite_ima
*/
#include "image.h"    /* types des donnees utilises */
#include "volume.h"   /* descripteurs et prototypes des fonctions de ima3D */
#include "M_coocur.h"
#include <stdlib.h>
#include <math.h>
#include <string.h>

extern GlcmAttribute attributes[];
int main(int argc, char *argv[])
{
  /* DECLARATIONS */

  /* images */
  ima3Du1 imscr;
  ima3Dd *imres[total_attributes];
  int i, s;

  Mcoocur_t des;

  /* main : variables et parametres propres au main*/
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */

  char *NomFicSortant;
  char *NomFicEntrant;
  char *tmp, *tmp2;

/* LECTURE PARAMETRES */

  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0);
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = Mcoocur_lect(&des, ptp, ">>Matrice de coocurance question :");

  /* main : en cas de parametres lus dans le main */

  lec_param(">>entrer le chemin et le nom de l'image a traiter", ptp);
  NomFicEntrant = strdup(ptp->rep);
  ptp = ptp->next;
  lec_param(">>entrer le chemin et le nom de l'image resultat", ptp);
  s = strlen(ptp->rep);
  NomFicSortant = (char *) malloc(s + 1 + 3);

  // Transform filename from /path/name.ext to /path/name_%s.ext
  strcpy(NomFicSortant, ptp->rep);
  tmp2 = strrchr(NomFicSortant, '.'); // last occurence of '.' (filname extension sepparator)
  if (tmp2 == 0)
    tmp2 = NomFicSortant + strlen(NomFicSortant); // or the end of the string
  strcpy(tmp2, "_%s"); // %s is to be replaced with the short name of the attribute
  tmp2 += 3;
  tmp = strrchr(ptp->rep, '.');
  if (tmp != 0)
    strcpy(tmp2, tmp); // add the file extension (if any)
  tmp2 -= 2;
  ptp = ptp->next;
  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);

  printf("fin de la lecture\n");

/* INITIALISATION  */

  /* operateur */
  //lect_ima3Du1( NomFicEntrant, &imscr, ALL);
  lect_volume_u1( NomFicEntrant, &imscr);
  printf("Lecture image OK\n");
  Mcoocur_init(&des, &imscr, imres);
  printf("init OK\n");

  /* CALCUL */

  Mcoocur_calc(&des, &imscr, imres);
  printf("calc OK\n");


  /* FERMETURE */

  tmp = (char *) malloc(s + 1 + 4 + 1); // original name + _ + short name + /0
  for (i = 0; i < total_attributes; i++)
    if (des.do_output[i]) {
        snprintf(tmp, s + 4 + 1, NomFicSortant, attributes[i].short_name);
        ecr_ima3Dd(tmp, imres[i]);
    }
}
