/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "distance3d.h"
#include <string.h>


int main(int argc, char *argv[])
{
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  carte_distance3d_t des; /*descripteur pour l'operateur de calcul de carte de distance*/
  char NomFicSortant [50]; /*fichier pour la sauvegarde du resultat*/
  ima3Du4 ima;
  ima3Du1 imaRes;
  unsigned x,y,z;


  /*--------lecture des paramtres-------------*/
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  ptp = carte_distance3d_lect( &des, ptp, ">>distance:");

  //lec_param(">>entrer le chemin et le nom de l'image resulat", ptp);
  //strcpy(NomFicSortant, ptp->rep);
  //ptp = ptp->next; 

  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);



  /*-------Initialisation-------------*/
  carte_distance3d_init( &des);
  printf("fin_init\n");

  /*creation d'une image de test*/
  ima.dimx = 100;
  ima.dimy = 100;
  ima.dimz = 100;
  allouer_ima3Du4(&ima);
 
  for(z=0; z<ima.dimz; z++)
    for(y=0; y<ima.dimy; y++)
      for(x=0; x<ima.dimx; x++)
	ima.data[z][y][x] = 1000000;

  ima.data[ima.dimz/2][ima.dimy/2][ima.dimx/2] = 0;


  /*lancement du calcul sur l'image de test*/
  printf("debut_calc\n");
  carte_distance3d_calc( &des, &ima);
  printf("fin_calc\n");


  /*sauvegarde des rsultats en passant par une image 8bits*/
  imaRes.dimz = ima.dimz;
  imaRes.dimy = ima.dimy;
  imaRes.dimx = ima.dimx;
  imaRes.lgtete = 24;
  imaRes.dept = 8;
  allouer_ima3Du1(&imaRes);

  /*copie de l'image rsultat avec troncature a 255*/
  for(z=0; z<ima.dimz; z++)
    for(y=0; y<ima.dimy; y++)
      for(x=0; x<ima.dimx; x++)
	if( (ima.data[z][y][x]/43) <= 255 )
	  imaRes.data[z][y][x] = (unsigned char)(ima.data[z][y][x]/43);
	else
	  imaRes.data[z][y][x] = 255;

  for(x=0; x<ima.dimx; x++)
    printf("%d--", ima.data[ima.dimz/2][ima.dimy/2][x]);

  /*ecriture image dans un fichier*/
  write_volume_u1( "test_distance.lvf", &imaRes);


}
