/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** 
\ingroup essai

messaiXX = u1 | etc : executable(s) associe(s) a l'operateur "essai" - programme type.\n
Entree : une image type XX = u1 | etc\n
Sortie : une image type XX = u1 | etc\n
Description : programme type illustrant la saisie de parametres 
et l'utilisation des operateurs read_ima, essai et write_ima.\n
Effectue une simple recopie de l'image entrante dans l'image sortante.

\author E. Trouve 
\version 1.0 (19/10/99)
\see lread_ima, lessai et lwrite_ima
*/
#include "volume.h"    /* types des donnees manipulees dans ima2D */
#include "proto2D.h"  /* descripteurs et prototypes des fonctions de ima2D */
#include "essai.h"    /* complement pour les operateurs en cours de developpt */ 
#include <stdlib.h>
#include <string.h>


int main(int argc, char *argv[]){

  param par0, *ptp;  /* variables pour la lecture des paramtres */
  int iloc;              
  float floc;
  char  nomlocIn[200], nomlocOut[200];

  ima3Du1 imaOri, imaRes; /*images a traiter*/  
  essai_t bid; /*operateurs en cours de dveloppement*/

  
  /*Lecture des paramtres*/
  param_debut(argc, argv, &par0); 
  ptp = &par0;  

  lec_param(">>main, fichier volume a lire", ptp);
  strcpy(nomlocIn, ptp->rep);
  ptp = ptp->next;  

  ptp = essai_lect(&bid, ptp, ">> essai_lect, debut de question :");

  lec_param(">>main, entier iloc", ptp);
  iloc = atoi(ptp->rep);
  ptp = ptp->next;

  lec_param(">>main, float floc", ptp);
  floc = (float)atof(ptp->rep);
  ptp = ptp->next;

  lec_param(">>main, fichier volume a ecrire", ptp);
  strcpy(nomlocOut, ptp->rep);
  ptp = ptp->next;  

  param_fin(argc, argv, &par0); /*fin lecture automatique des paramtres*/



  /*Initialisation et lecture*/
  lect_volume_u1( nomlocIn, &imaOri);
  essaiu1_init(&bid, imaOri, &imaRes);

 
  /*Traitement*/
  essaiu1_calc(&bid, imaOri, &imaRes); 
  printf("\n partie calcul, iloc=%d, floc=%f, nomlocIn=%s, nomlocOut=%s\n", 
	 iloc, floc, nomlocIn, nomlocOut);


  /*Ecriture de l'image resultat*/
  write_volume_u1( nomlocOut, &imaRes) ; 
}

