/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/


#include <string.h>
#include "gradient_organisation.h"


#define MAX(x,y) (((x)>(y))? (x):(y))


int main(int argc, char *argv[])
{

  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  char NomFicEntrant[50];
  char NomFicSortant[50];
  ogi_t des;
  ima3Du1 imsrc;
  ima3Du1 imres;
  register unsigned int z;

  /*lecture des paramtres*/
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  lec_param(">>entrer le chemin et le nom de l'image a traiter", ptp);
  strcpy(NomFicEntrant, ptp->rep);
  ptp = ptp->next;  

  ptp = gradient_organisation_lect( &des, ptp, ">>ogi:");

  lec_param(">>entrer le chemin et le nom de l'image resulat", ptp);
  strcpy(NomFicSortant, ptp->rep);
  ptp = ptp->next; 

  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);
  

  
  /*chargement des premieres sections et allocation des images*/
  lect_volume_u1_sequence_first( NomFicEntrant, &imsrc, MAX(des.tgrad,des.az) );
  copie_entete_ima3du1( &imsrc, &imres); 
  imres.sequence_width=1; 
  imres.sequence_number=0; 
  allouer_ima3Du1_sequence(&imres); 
  write_volume_u1_sequence_preparation( NomFicSortant, &imres, 0);


  /*initialisation de l'operateur*/
  gradient_organisation_init( &des, &imsrc);


  /*calcul pour chaque section*/
  /*
  for( z=MAX(des.tgrad,des.az)/2; z < (imsrc.dimz-MAX(des.tgrad,des.az)/2); z++){
    printf("section %d/%d\n", z, imsrc.dimz);
    gradient_organisation_calc( &des, &imsrc, &imres);
    write_volume_u1_sequence_next( &imres);
    lect_volume_u1_sequence_next( &imsrc);
  }
  */
  
  gradient_organisation_calc( &des, &imsrc, &imres);

  /*fermeture de l'image rsultat*/
  //write_volume_u1_sequence_fermeture(&imres, MAX(des.tgrad,des.az)/2 );

  /*fermerture de l'operateur*/
  gradient_organisation_ferm( &des);


}
