/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** XX = u1 : executable(s) associe(s) a l'operateur "median".\\
Entree : une image type XX = u1\\
Sortie : une image type XX = u1\\
Description : Programme realisant la median 3D a 3 parametres X,Y et Z constituant le masque.
@name median3d
@author G. Marinescu 
@version 1 (01.04.03)
@see lread_ima, lessai et lwrite_ima
*/
#include "image.h"    /* types des donnees utilises */
#include "volume.h"   /* descripteurs et prototypes des fonctions de ima3D */
#include "median3d.h"    /* complement pour les operateurs en cours de developpement */ 
#include <stdlib.h>
#include <math.h>
#include <string.h>

int main(int argc, char *argv[])
{
  /* DECLARATIONS */

  /* images */ 
  ima3Du1 imscr;
  ima3Du1 imres;


  median3d_t tMasque;
 // write_ima_t wri;   
 
  /* main : variables et parametres propres au main*/
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  
  char NomFicSortant [50];
  char NomFicEntrant[50];

/* LECTURE PARAMETRES */

  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = median3d_lect(&tMasque, ptp, ">>median3d question :");

  /* main : en cas de parametres lus dans le main */

  lec_param(">>entrer le chemin et le nom de l'image a traiter", ptp);
  strcpy(NomFicEntrant, ptp->rep);
  ptp = ptp->next;  
  lec_param(">>entrer le chemin et le nom de l'image resulat", ptp);
  strcpy(NomFicSortant, ptp->rep);
  ptp = ptp->next; 
  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);


/* INITIALISATION  */

  /* operateur */
  printf("\n fichier source %s",NomFicEntrant);
  printf("\n fichier dest %s\n",NomFicSortant);
  lect_ima3Du1 (NomFicEntrant,&imscr,ALL);
  printf (" format de l'image source %d %d %d\n",imscr.dimx,imscr.dimy,imscr.dimz);
  median3d_init(&tMasque,imscr,&imres);
  /* main : en cas de variable a allouer/initialiser dans le main  */ 
  // printf("\n fin init\n");
  /* CALCUL */
  if (imscr.dimx<tMasque.winX) tMasque.winX=imscr.dimx+imscr.dimx%2-1;
  if (imscr.dimy<tMasque.winY) tMasque.winY=imscr.dimy+imscr.dimy%2-1;
  if (imscr.dimz<tMasque.winZ) tMasque.winZ=imscr.dimz+imscr.dimz%2-1;
  median3d_calc(&tMasque,imscr,&imres); 

  printf("\n fin calcul avec le  masque %dx%dx%d, nomfichierRes: %s\n",
	 tMasque.winX,tMasque.winY,tMasque.winZ,NomFicSortant);

/* FREMETURE */
  ecr_ima3Du1 (NomFicSortant,&imres);
}

