/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
/** XX = u1 : executable(s) associe(s) a l'operateur "median".\\
Entree : une image type XX = u1\\
Sortie : une image type XX = u1\\
Description : Programme realisant la median 3D a 3 parametres X,Y et Z constituant le masque.
@name median3d
@author G. Marinescu 
@version 1 (01.04.03)
@see lread_ima, lessai et lwrite_ima
*/
//#include "image.h"    /* types des donnees utilises */
//#include "volume.h"   /* descripteurs et prototypes des fonctions de ima3D */
#include "reggr3d.h"    /* complement pour les operateurs en cours de developpement */ 
#include <stdlib.h>
#include <math.h>
#include <string.h>

#include "permut.h"
#include "volume.h"


/**lecture d'une image sismique, sortie 8bits

Si l'image d'entre est au format 16bits, les valeurs ont ramenes sur 8bits en ajutant la dynamique par rapport au min/max des valeurs d'entres.

@see lect_imaSisS2
*/







int main(int argc, char *argv[])
{
  /* DECLARATIONS */

  /* images */ 
  ima3Du1 imscr;
  ima3Du4 imres;

  reggr3d_t des;
 // write_ima_t wri;   
  /* main : variables et parametres propres au main*/
  param par0, *ptp;      /* tete et pointeur pour la chaine de parametres */
  
  char NomFicSortant [50];
  char NomFicEntrant[50];

/* LECTURE PARAMETRES */

  /* debut: OBLIGATOIRE pour compatibilite avec les 3 modes de lecture de param */
  param_debut(argc, argv, &par0); 
  ptp = &par0;      /* regle : ptp pointe sur la structure du parametre suivant */

  /* operateurs: ptp est passe en argument, return fournit la nouvelle position */
  ptp = reggr3d_lect(&des, ptp, ">>reggr3d question :");

  /* main : en cas de parametres lus dans le main */

  lec_param(">>entrer le chemin et le nom de l'image a traiter", ptp);
  strcpy(NomFicEntrant, ptp->rep);
  ptp = ptp->next;  
  lec_param(">>entrer le chemin et le nom de l'image resulat", ptp);
  strcpy(NomFicSortant, ptp->rep);
  ptp = ptp->next; 
  /* fin: sauvegarde des parametres utilises en mode MANUEL ou FICHIER */
  param_fin(argc, argv, &par0);


/* INITIALISATION  */
  
  /* operateur */
  printf("\n fichier source %s",NomFicEntrant);
  printf("\n fichier dest %s\n",NomFicSortant);
  lect_ima3Du1 (NomFicEntrant, &imscr,ALL);
  //lect_imaSis(NomFicEntrant, &imscr, ALL);
  printf (" format de l'image source %d %d %d\n",imscr.dimx,imscr.dimy,imscr.dimz);


  reggr3d_init(&des, &imscr,&imres);
  /* main : en cas de variable a allouer/initialiser dans le main  */ 
  // printf("\n fin init\n");
  /* CALCUL */

  //printf("ima1 x=%d, ima2 x=%d\n", imscr.dimx, imres.dimx);
  reggr3d_calc(&des,&imscr,&imres);
  printf("Fin du calcul\n");

  /* FREMETURE */
  //ecr_ima3Du1( NomFicSortant, &imres);
  printf("Ecriture fichier \n");
  ecr_ima3Du1( NomFicSortant, &imscr);
  printf("ok \n");
}




