/*
*    Copyright (c) 2007. The BATI team. All right reserved.
*
*    This file is part of BATI library.
*
*    BATI library is free software: you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation, either version 3 of the License, or
*    (at your option) any later version.
*
*    BATI library  is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with BATI library.  If not, see <http://www.gnu.org/licenses/>.
*/
#include <stdio.h>
#include "volume.h"
#include <stdlib.h>

/**
Caractristique d'une image sismique.\\
Cet executable returne les valeurs caractristiques d'une image sismique. C'est a dire la longueur des traces, leur nombre, le nombre de plan mais aussi le codage de chaque pixel (nombre de bit) et la longueur de l'entete en octet.\\
Utilisation:\\
param <fichier image ELF> -h help

@name param
@author Lionel VALET
@version Mai 1999
*/


int main(argc,argv)
    int argc;
    char *argv[];
{

  int VAL;
  FILE *fin;

if (argc<2 || strcmp (argv[1],"-h") == 0 )
    {
	printf("\nparam <fichier image ELF>\n  -h help\n\n");
	exit(1);
    }

if ( (fin=fopen(argv[1],"r"))==NULL )
    {
	printf("Erreur a l'ouverture du fichier.\n");
	exit(1);
    }

  lire_longueur_trace(fin,&VAL);
  printf("dimx=%d  ",VAL);
  lire_nb_trace(fin,&VAL); 
  printf("dimy=%d  ",VAL);
  lire_nb_plan(fin,&VAL);
  printf("dimz=%d  ",VAL);
  lire_nb_octet(fin,&VAL); 
  printf("Nb_bit=%d  ",VAL);
  lire_longueur_entete(fin,&VAL); 
  printf("dim_entete=%d\n",VAL);
}
